(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var _ = Package.underscore._;
var Random = Package.random.Random;
var Router = Package['iron:router'].Router;
var RouteController = Package['iron:router'].RouteController;
var Accounts = Package['accounts-base'].Accounts;
var check = Package.check.check;
var Match = Package.check.Match;
var SHA256 = Package.sha.SHA256;
var Email = Package.email.Email;
var Iron = Package['iron:core'].Iron;

(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                             //
// packages/accounts-email-token/token_common.js                                                               //
//                                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                               //
Accounts.emailToken = {};                                                                                      // 1
                                                                                                               // 2
Accounts.emailToken._hashToken = function (token) {                                                            // 3
  return {                                                                                                     // 4
    digest: SHA256(token),                                                                                     // 5
    algorithm: "sha-256"                                                                                       // 6
  };                                                                                                           // 7
};                                                                                                             // 8
                                                                                                               // 9
var enabled = false;                                                                                           // 10
                                                                                                               // 11
Accounts.emailToken.enable = function () {                                                                     // 12
  enabled = true;                                                                                              // 13
  if (Meteor.isClient) {                                                                                       // 14
    Accounts.ui.registerService("emailToken", "an Email + Token");                                             // 15
  }                                                                                                            // 16
};                                                                                                             // 17
                                                                                                               // 18
Accounts.emailToken.disable = function () {                                                                    // 19
  enabled = false;                                                                                             // 20
  if (Meteor.isClient) {                                                                                       // 21
    Accounts.ui.deregisterService("emailToken");                                                               // 22
  }                                                                                                            // 23
};                                                                                                             // 24
                                                                                                               // 25
Accounts.emailToken.isEnabled = function () {                                                                  // 26
  return enabled;                                                                                              // 27
};                                                                                                             // 28
                                                                                                               // 29
Router.route("/_emailToken/:_email/:_token", function () {                                                     // 30
  this.render("Loading");                                                                                      // 31
  var that = this;                                                                                             // 32
  Meteor.loginWithEmailToken(this.params._email, this.params._token, function (err) {                          // 33
    if (err) {                                                                                                 // 34
      that.render("_emailTokenError", {                                                                        // 35
        data: function () {                                                                                    // 36
          return {                                                                                             // 37
            error: err                                                                                         // 38
          };                                                                                                   // 39
        }                                                                                                      // 40
      });                                                                                                      // 41
    } else {                                                                                                   // 42
      Router.go("/");                                                                                          // 43
    }                                                                                                          // 44
  });                                                                                                          // 45
});                                                                                                            // 46
                                                                                                               // 47
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                             //
// packages/accounts-email-token/token_server.js                                                               //
//                                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                               //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                      // 1
                                                                                                               // 2
var cleanupExpiredTokens = function() {                                                                        // 3
  Meteor.users.update({}, {                                                                                    // 4
    $pull: {                                                                                                   // 5
      "services.emailToken.tokens": {                                                                          // 6
        createdAt: {$lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)}                                           // 7
      }                                                                                                        // 8
    }                                                                                                          // 9
  }, { multi: true });                                                                                         // 10
};                                                                                                             // 11
                                                                                                               // 12
Meteor.startup(cleanupExpiredTokens);                                                                          // 13
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                      // 14
Meteor.setInterval(cleanupExpiredTokens, TOKEN_EXPIRATION_MS);                                                 // 15
                                                                                                               // 16
var checkToken = function (user, token) {                                                                      // 17
  var found = false;                                                                                           // 18
  user.services.emailToken.tokens.forEach(function (userToken) {                                               // 19
    if((userToken.algorithm === token.algorithm) &&                                                            // 20
       (userToken.digest === token.digest)) {                                                                  // 21
      found = true;                                                                                            // 22
    }                                                                                                          // 23
  });                                                                                                          // 24
                                                                                                               // 25
  return found;                                                                                                // 26
};                                                                                                             // 27
                                                                                                               // 28
// Handler to login with a token.                                                                              // 29
Accounts.registerLoginHandler("emailToken", function (options) {                                               // 30
  if (!options.emailToken)                                                                                     // 31
    return undefined; // don't handle                                                                          // 32
                                                                                                               // 33
  options = options.emailToken;                                                                                // 34
  check(options, {                                                                                             // 35
    email: String,                                                                                             // 36
    token: String                                                                                              // 37
  });                                                                                                          // 38
                                                                                                               // 39
  var user = Meteor.users.findOne({"services.emailToken.email": options.email});                               // 40
                                                                                                               // 41
  if (!user) {                                                                                                 // 42
    console.error("User not found:", options.email);                                                           // 43
    return {                                                                                                   // 44
      error: new Meteor.Error(403, "User not found")                                                           // 45
    };                                                                                                         // 46
  }                                                                                                            // 47
                                                                                                               // 48
  if (!user.services || !user.services.emailToken ||                                                           // 49
      !(user.services.emailToken.tokens)) {                                                                    // 50
    console.error("User has no token set:", options.email);                                                    // 51
    return {                                                                                                   // 52
      error: new Meteor.Error(403, "User has no token set")                                                    // 53
    };                                                                                                         // 54
  }                                                                                                            // 55
                                                                                                               // 56
  var token = Accounts.emailToken._hashToken(options.token);                                                   // 57
  var found = checkToken(                                                                                      // 58
    user,                                                                                                      // 59
    token                                                                                                      // 60
  );                                                                                                           // 61
                                                                                                               // 62
  if (!found) {                                                                                                // 63
    console.error("Token not found:", user.services.emailToken);                                               // 64
    return {                                                                                                   // 65
      error: new Meteor.Error(403, "Invalid authentication code")                                              // 66
    };                                                                                                         // 67
  }                                                                                                            // 68
                                                                                                               // 69
  Meteor.users.update({_id: user._id}, {$pull: {"services.emailToken.tokens": token}});                        // 70
  return {                                                                                                     // 71
    userId: user._id                                                                                           // 72
  };                                                                                                           // 73
});                                                                                                            // 74
                                                                                                               // 75
var Url = Npm.require("url");                                                                                  // 76
                                                                                                               // 77
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                // 78
var HOSTNAME = ROOT_URL.hostname;                                                                              // 79
                                                                                                               // 80
var makeTokenUrl = function (email, token) {                                                                   // 81
  return process.env.ROOT_URL + "/_emailToken/" + encodeURIComponent(email) + "/" + encodeURIComponent(token); // 82
};                                                                                                             // 83
                                                                                                               // 84
///                                                                                                            // 85
/// EMAIL VERIFICATION                                                                                         // 86
///                                                                                                            // 87
var sendTokenEmail = function (email, token) {                                                                 // 88
  var options = {                                                                                              // 89
    to:  email,                                                                                                // 90
    from: HOSTNAME + " <no-reply@" + HOSTNAME + ">",                                                           // 91
    subject: "Log in to " + HOSTNAME,                                                                          // 92
    text: "To log in to " + HOSTNAME + ", click on the following link:\n\n" +                                  // 93
          makeTokenUrl(email, token) + "\n\n" +                                                                // 94
          "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" +        // 95
          token + "\n\n" +                                                                                     // 96
          "You are receiving this because someone (hopefully you) requested to log in to HOSTNAME " +          // 97
          "with your email address. If you did not request to log into " + HOSTNAME + ", you may " +           // 98
          "ignore this message.\n\n" +                                                                         // 99
          "This information will expire in 15 minutes.\n"                                                      // 100
  };                                                                                                           // 101
                                                                                                               // 102
  Email.send(options);                                                                                         // 103
};                                                                                                             // 104
                                                                                                               // 105
///                                                                                                            // 106
/// CREATING USERS                                                                                             // 107
///                                                                                                            // 108
// returns the user id                                                                                         // 109
var createAndEmailTokenForUser = function (email) {                                                            // 110
  check(email, String);                                                                                        // 111
  var atIndex = email.indexOf("@");                                                                            // 112
  if (atIndex === -1) {                                                                                        // 113
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                        // 114
  }                                                                                                            // 115
                                                                                                               // 116
  var username = email.slice(0, atIndex);                                                                      // 117
                                                                                                               // 118
  var user = Meteor.users.findOne({"services.emailToken.email": email});                                       // 119
  var userId;                                                                                                  // 120
                                                                                                               // 121
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                         // 122
  var token = Random.id(12);                                                                                   // 123
  var tokenObj = Accounts.emailToken._hashToken(token);                                                        // 124
  tokenObj.createdAt = new Date();                                                                             // 125
                                                                                                               // 126
  if (user) {                                                                                                  // 127
    if (user.services.emailToken.tokens && user.services.emailToken.tokens.length > 2) {                       // 128
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " +           // 129
        "ago. Please use the one that was already sent (check your spam folder if you can't find " +           // 130
        "it), or wait a while and try again");                                                                 // 131
    }                                                                                                          // 132
    userId = user._id;                                                                                         // 133
                                                                                                               // 134
    Meteor.users.update({_id: userId}, {$push: {"services.emailToken.tokens": tokenObj}});                     // 135
  } else {                                                                                                     // 136
    var options = {                                                                                            // 137
      email: email,                                                                                            // 138
      profile: {                                                                                               // 139
        name: username                                                                                         // 140
      }                                                                                                        // 141
    };                                                                                                         // 142
                                                                                                               // 143
    user = {services: {emailToken: {                                                                           // 144
      tokens: [tokenObj],                                                                                      // 145
      email: options.email                                                                                     // 146
    }}};                                                                                                       // 147
                                                                                                               // 148
    userId = Accounts.insertUserDoc(options, user);                                                            // 149
  }                                                                                                            // 150
                                                                                                               // 151
  sendTokenEmail(email, token);                                                                                // 152
                                                                                                               // 153
  return userId;                                                                                               // 154
};                                                                                                             // 155
                                                                                                               // 156
// method for create user. Requests come from the client.                                                      // 157
// This method will create a user if it doesn't exist, otherwise it will generate a token.                     // 158
// It will always send an email to the user                                                                    // 159
Meteor.methods({createAndEmailTokenForUser: function (email) {                                                 // 160
  if (!Accounts.emailToken.isEnabled()) {                                                                      // 161
    throw new Meteor.Error(403, "Email Token service is disabled.");                                           // 162
  }                                                                                                            // 163
  // Create user. result contains id and token.                                                                // 164
  var user = createAndEmailTokenForUser(email);                                                                // 165
}});                                                                                                           // 166
                                                                                                               // 167
///                                                                                                            // 168
/// INDEXES ON USERS                                                                                           // 169
///                                                                                                            // 170
Meteor.users._ensureIndex("services.emailToken.email",                                                         // 171
                          {unique: 1, sparse: 1});                                                             // 172
                                                                                                               // 173
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-email-token'] = {};

})();

//# sourceMappingURL=accounts-email-token.js.map
